import 'package:diplomaticquarterapp/uitl/utils_new.dart';
import 'package:diplomaticquarterapp/widgets/charts/app_time_series_chart.dart';
import 'package:fl_chart/fl_chart.dart';
import 'package:flutter/material.dart';

import '../../../Constants.dart';

class LineChartCurved extends StatelessWidget {
  final String title;
  final List<TimeSeriesSales2> timeSeries;
  final int indexes;
  final double horizontalInterval;

  LineChartCurved({this.title, this.timeSeries, this.indexes, this.horizontalInterval = 20.0});

  List<int> xAxixs = List();
  List<double> yAxixs = List();

  double minY = 0;
  double maxY = 0;
  double intialY = 0;
  double lastY = 0;

  double minX = 0;
  double maxX = 0;
  double increasingY = 0;

  @override
  Widget build(BuildContext context) {
    getXaxix();
    getYaxix();
    getInitialY();
    calculateMaxAndMin();
    return AspectRatio(
      aspectRatio: 1.0,
      child: Container(
        decoration: const BoxDecoration(
          borderRadius: BorderRadius.all(Radius.circular(18)),
          // color: Colors.white,
        ),
        child: Stack(
          children: <Widget>[
            Column(
              crossAxisAlignment: CrossAxisAlignment.stretch,
              children: <Widget>[
                Row(
                  crossAxisAlignment: CrossAxisAlignment.start,
                  children: [
                    Padding(
                      padding: const EdgeInsets.all(16.0),
                      child: Text(
                        title,
                        style: TextStyle(color: Colors.black, fontSize: 16, letterSpacing: -0.64, fontWeight: FontWeight.w600),
                        textAlign: TextAlign.center,
                      ),
                    ),
                  ],
                ),
                mHeight(10),
                Expanded(
                  child: Padding(
                    padding: const EdgeInsets.only(right: 18.0, left: 16.0),
                    child: LineChart(
                      sampleData1(context),
                      swapAnimationDuration: const Duration(milliseconds: 250),
                    ),
                  ),
                ),
                const SizedBox(
                  height: 10,
                ),
              ],
            ),
          ],
        ),
      ),
    );
  }

  getXaxix() {
    for (int index = 0; index < timeSeries.length; index++) {
      int mIndex = indexes * index;
      if (mIndex < timeSeries.length) {
        xAxixs.add(mIndex);
      }
    }
  }

  getYaxix() {
    for (int index = 0; index < timeSeries.length; index++) {
      int mIndex = indexes * index;
      if (mIndex < timeSeries.length) {
        yAxixs.add(timeSeries[mIndex].sales);
      }
    }
  }

  LineChartData sampleData1(context) {
    return LineChartData(
      lineTouchData: LineTouchData(
        touchTooltipData: LineTouchTooltipData(
          tooltipBgColor: Colors.white,
        ),
        touchCallback: (touchEvent, LineTouchResponse touchResponse) {},
        handleBuiltInTouches: true,
      ),
      gridData: FlGridData(show: true, drawVerticalLine: true, drawHorizontalLine: true, horizontalInterval: 14, verticalInterval: 14),
      titlesData: FlTitlesData(
        bottomTitles: SideTitles(
          showTitles: true,
          getTextStyles: (cxt, value) => const TextStyle(
            color: Colors.black,
            fontSize: 10,
          ),
          rotateAngle: -65,
          margin: 22,
          getTitles: (value) {
            if (timeSeries.length < 15) {
              if (timeSeries.length > value.toInt()) {
                return '${timeSeries[value.toInt()].time.month}/ ${timeSeries[value.toInt()].time.year}';
              } else
                return '';
            } else {
              if (value.toInt() == 0) return '${timeSeries[value.toInt()].time.month}/ ${timeSeries[value.toInt()].time.year}';
              if (value.toInt() == timeSeries.length - 1) return '${timeSeries[value.toInt()].time.month}/ ${timeSeries[value.toInt()].time.year}';
              if (xAxixs.contains(value.toInt())) {
                return '${timeSeries[value.toInt()].time.month}/ ${timeSeries[value.toInt()].time.year}';
              }
            }
            return '';
          },
        ),
        leftTitles: SideTitles(
          showTitles: true,
          getTextStyles: (cxt, value) => const TextStyle(
            color: Colors.black,
            fontWeight: FontWeight.bold,
            fontSize: 10,
          ),
          interval: 3.0,
          margin: 12,
        ),
      ),
      borderData: FlBorderData(
        show: true,
        border: const Border(
          bottom: BorderSide(
            color: Colors.black,
            width: 0.5,
          ),
          left: BorderSide(
            color: Colors.black,
          ),
          right: BorderSide(
            color: Colors.black,
          ),
          top: BorderSide(
            color: Colors.transparent,
          ),
        ),
      ),
      minX: minX,
      maxX: maxX,
      maxY: lastY + 1,
      minY: intialY - 0.5,
      lineBarsData: getData(context),
    );
  }

  calculateMaxAndMin() {
    getMaxY();
    getMaxX();
    getMin();
    getMinY();
    increasingY = ((maxY - minY) / timeSeries.length - 1) * 15;
    maxY += increasingY.abs();
    minY -= increasingY.abs();
  }

  double getMaxY() {
    maxY = 0;
    timeSeries.forEach((element) {
      double resultValueDouble = element.sales;
      if (resultValueDouble > maxY) {
        lastY = resultValueDouble;
        maxY = resultValueDouble;
      }
    });
    print("maxY " + lastY.toString());
    return maxY.roundToDouble();
  }

  double getInitialY() {
    try {
      intialY = timeSeries.first.sales;
      timeSeries.forEach((element) {
        double resultValueDouble = element.sales;
        if (resultValueDouble < intialY) intialY = resultValueDouble;
      });
    } catch (e) {
      intialY = 0;
    }

    print("minY " + intialY.toString());
    return intialY.roundToDouble();
  }

  getMaxX() {
    maxX = (timeSeries.length - 1).toDouble();
  }

  double getMin() {
    minX = 0;
    timeSeries.forEach((element) {
      double resultValueDouble = element.sales;
      if (resultValueDouble < minX) minX = resultValueDouble;
    });

    return minX.roundToDouble();
  }

  double getMinY() {
    minY = 0;
    timeSeries.forEach((element) {
      double resultValueDouble = element.sales;
      if (resultValueDouble < minY) minY = resultValueDouble;
    });
    int value = minY.toInt();

    return value.toDouble();
  }

  List<LineChartBarData> getData(context) {
    List<FlSpot> spots = List();
    for (int index = 0; index < timeSeries.length; index++) {
      spots.add(FlSpot(index.toDouble(), timeSeries[index].sales));
    }

    final LineChartBarData lineChartBarData1 = LineChartBarData(
      spots: spots,
      isCurved: true,
      colors: [secondaryColor],
      barWidth: 1.5,
      isStrokeCapRound: true,
      dotData: FlDotData(
        show: false,
      ),
      belowBarData: BarAreaData(
        show: false,
      ),
    );

    return [
      lineChartBarData1,
    ];
  }
}
